OSDN Git Service

Daily bump.
[pf3gnuchains/gcc-fork.git] / contrib / compare-debug
index 9864ee9..010d17f 100755 (executable)
@@ -2,7 +2,7 @@
 
 # Compare stripped copies of two given object files.
 
-# Copyright (C) 2007, 2008, 2009 Free Software Foundation
+# Copyright (C) 2007, 2008, 2009, 2010 Free Software Foundation
 # Originally by Alexandre Oliva <aoliva@redhat.com>
 
 # This file is part of GCC.
@@ -57,11 +57,21 @@ done
 
 trap 'rm -f "$1.$suf1" "$2.$suf2"' 0 1 2 15
 
-cp "$1" "$1.$suf1"
-strip "$1.$suf1"
+case `uname -s` in
+Darwin)
+  # The strip command on darwin does not remove all debug info.
+  # Fortunately, we can use ld to do it instead.
+  ld -S -r -no_uuid "$1" -o "$1.$suf1"
+  ld -S -r -no_uuid "$2" -o "$2.$suf2"
+  ;;
+*)
+  cp "$1" "$1.$suf1"
+  strip "$1.$suf1"
 
-cp "$2" "$2.$suf2"
-strip "$2.$suf2"
+  cp "$2" "$2.$suf2"
+  strip "$2.$suf2"
+  ;;
+esac
 
 if cmp "$1.$suf1" "$2.$suf2"; then
   status=0
@@ -78,7 +88,7 @@ else
   cmp2=
 
   for t in objdump readelf eu-readelf; do
-    if ($t --help) 2>&1 | grep -e '--\[*section-\]*headers' > /dev/null; then
+    if ($t --help) 2>&1 | grep --\[*section-\]*headers' > /dev/null; then
       cmd=$t
 
       $cmd --section-headers "$1.$suf1" | grep '\.eh_frame' > /dev/null
@@ -92,9 +102,11 @@ else
   done
 
   # If we found .eh_frame in one but not the other, or if we could not
-  # find a command to tell, try to strip off the .eh_frame section
-  # from both.
-  if test "x$cmp1" != "x$cmp2" || test "x$cmd" = "x"; then
+  # find a command to tell, or if there are LTO sections, try to strip
+  # off the .eh_frame and LTO sections from both.
+  if test "x$cmp1" != "x$cmp2" || test "x$cmd" = "x" ||
+     $cmd --section-headers "$1.$suf1" | grep '.gnu.lto_' > /dev/null ||
+     $cmd --section-headers "$2.$suf2" | grep '.gnu.lto_' > /dev/null ; then
     suf3=$suf1.
     while test -f "$1.$suf3"; do
       suf3=$suf3.
@@ -107,21 +119,27 @@ else
 
     trap 'rm -f "$1.$suf1" "$2.$suf2" "$1.$suf3" "$2.$suf4"' 0 1 2 15
 
-    echo stripping off .eh_frame, then retrying >&2
+    echo stripping off .eh_frame and LTO sections, then retrying >&2
+
+    seclist=".eh_frame .rel.eh_frame .rela.eh_frame"
+    if test "x$cmd" != "x"; then
+      seclist="$seclist "`{ $cmd --section-headers "$1.$suf1"; $cmd --section-headers "$2.$suf2"; } | sed -n 's,.* \(\.gnu\.lto_[^     ]*\).*,\1,p' | sort -u`
+    fi
+    rsopts=`for sec in $seclist; do echo " --remove-section $sec"; done`
 
-    if (objcopy -v) 2>&1 | grep -e "--remove-section" > /dev/null; then
-      objcopy --remove-section .eh_frame --remove-section .rel.eh_frame --remove-section .rela.eh_frame "$1.$suf1" "$1.$suf3"
+    if (objcopy -v) 2>&1 | grep ' --remove-section' > /dev/null; then
+      objcopy $rsopts "$1.$suf1" "$1.$suf3"
       mv "$1.$suf3" "$1.$suf1"
 
-      objcopy --remove-section .eh_frame --remove-section .rel.eh_frame --remove-section .rela.eh_frame "$2.$suf2" "$2.$suf4"
+      objcopy $rsopts "$2.$suf2" "$2.$suf4"
       mv "$2.$suf4" "$2.$suf2"
-    elif (strip --help) 2>&1 | grep -e --remove-section > /dev/null; then
+    elif (strip --help) 2>&1 | grep ' --remove-section' > /dev/null; then
       cp "$1.$suf1" "$1.$suf3"
-      strip --remove-section .eh_frame --remove-section .rel.eh_frame --remove-section .rela.eh_frame "$1.$suf3"
+      strip $rsopts "$1.$suf3"
       mv "$1.$suf3" "$1.$suf1"
 
       cp "$2.$suf2" "$2.$suf4"
-      strip --remove-section .eh_frame --remove-section .rel.eh_frame --remove-section .rela.eh_frame "$2.$suf4"
+      strip $rsopts "$2.$suf4"
       mv "$2.$suf4" "$2.$suf2"
     else
       echo failed to strip off .eh_frame >&2
@@ -141,4 +159,12 @@ $rm "$1.$suf1" "$2.$suf2"
 
 trap "exit $status; exit" 0 1 2 15
 
+if test -f "$1".gkd || test -f "$2".gkd; then
+  if cmp "$1".gkd "$2".gkd; then
+    :
+  else
+    status=$?
+  fi
+fi
+
 exit $status